searchNodes=[{"ref":"FluxAMQP.html","title":"FluxAMQP","type":"module","doc":"Interface to connect to AMQP broker, sending and retrieving messages. It uses AMQP, check their documentation to understand how this library perform the connection, configuration, consumption and delivery of AMQP messages. Check FluxAMQP.Consumer to read about how to consume AMQP messages. Check send/3 to read about how to send AMQP message. Configuration import Config # Default values config :flux_amqp, broker: [uri: &quot;amqp://guest:guest@rabbitmq&quot;], reconnection: [ maximum_attempts: -1, waiting_ms: 10_000 ], routing_keys: [] Configuration Options broker - Set the broker which will be consumed and delivered messages. Options are: uri - The AMQP Broker URI. reconnection - A keyword list with reconnection options. Options are: maximum_attempts - How many attempts should be performed in case of connection failure. If set as -1, it will try until connection succeed. waiting_ms - How many milliseconds should wait before reattempting connection. If set as -1, it will not reattempt connection. routing_keys - The AMQP routing keys which the messages will be consumed."},{"ref":"FluxAMQP.html#close_connection/1","title":"FluxAMQP.close_connection/1","type":"function","doc":"Closes an open Connection. Parameters connection - The AMQP.Connection struct. Examples iex&gt; {:ok, connection} = FluxAMQP.connect(__MODULE__, only_connect?: true) ...&gt; FluxAMQP.close_connection(connection) :ok"},{"ref":"FluxAMQP.html#connect/2","title":"FluxAMQP.connect/2","type":"function","doc":"Open a Connection and configure it. Parameters consumer - The module which will consume AMQP messages. opts - Keyword list with options (merged with application configuration). Examples iex&gt; result = FluxAMQP.connect(__MODULE__, only_connect?: true) ...&gt; with {:ok, %AMQP.Connection{}} &lt;- result, do: :passed :passed iex&gt; result = FluxAMQP.connect(__MODULE__) ...&gt; with {:ok, %AMQP.Channel{}} &lt;- result, do: :passed :passed Options broker_uri - The AMQP Broker URI. Defaults to application configuration. reconnection - A keyword list with reconnection options. Options are: maximum_attempts - How many attempts should be performed in case of connection failure. Defaults to application configuration. If set as -1, it will try until connection succeed. waiting_ms - How many milliseconds should wait before reattempting connection. Defaults to application configuration. If set as -1, it will not reattempt connection. routing_keys - The AMQP routing keys which the messages will be consumed. Defaults to application configuration."},{"ref":"FluxAMQP.html#send/3","title":"FluxAMQP.send/3","type":"function","doc":"Send AMQP message. Parameters payload: The message string. routing_key: The AMQP routing key which the message will be sent. opts: Keyword list with options (merged with application configuration). Examples iex&gt; FluxAMQP.Sender.send( ...&gt; &quot;Hello, World!&quot;, ...&gt; &quot;some.amqp.route&quot;, ...&gt; broker_uri: &quot;amqp://guest:guest@rabbitmq&quot;, ...&gt; close_connection?: true, ...&gt; declare_exchange?: true, ...&gt; reconnection: [maximum_attempts: 3, waiting_ms: 5_000] ...&gt;) :ok Options broker_uri: The AMQP Broker URI. Defaults to application configuration. channel: A valid AMQP.Channel struct. If not set, a new channel will be created. close_connection?: If true, it will close the connection. Defaults to true. connection: A valid AMQP.Connection. declare_exchange?: If true, it will declare the AMQP exchange into channel. Defaults to true. exchange: A string with valid AMQP exchange definition. If not set, amq.topic will be used. publish_options: A Keyword list with valid AMQP.Basic.publish/5 options. Defaults to empty Keyword list. reconnection: A Keyword list with reconnection options. See connect/2 for more information."},{"ref":"FluxAMQP.Consumer.html","title":"FluxAMQP.Consumer","type":"behaviour","doc":"Module responsible to consume AMQP messages. The main approach to consume is done by defining a module which use FluxAMQP.Consumer and implements routing_keys/0 and consume/3 functions: defmodule MyApp.AMQP.Consumer do use FluxAMQP.Consumer @impl FluxAMQP.Consumer def routing_keys do [ &quot;route.example&quot;, {&quot;another.route.example&quot;, &quot;amq.direct&quot;} ] end @impl FluxAMQP.Consumer def consume(channel, delivery_tag, routing_key, payload) do # Handle message end end If routing_keys/0 returns an empty list, FluxAMQP will try to extract the routing keys from the application :flux_amqp configuration."},{"ref":"FluxAMQP.Consumer.html#c:consume/3","title":"FluxAMQP.Consumer.consume/3","type":"callback","doc":""},{"ref":"FluxAMQP.Consumer.html#c:routing_keys/0","title":"FluxAMQP.Consumer.routing_keys/0","type":"callback","doc":""}]